

problem cover;
#------------------------------
option solver cplex;
param nRows integer, >=1;                                       #numero delle righe
param nCols integer;                                       #numero delle colonne
set rows:=1..nRows;                                             #insieme delle righe
set cols:=1..nCols;                                             #insieme delle colonne
param A{rows,cols} binary;                                      #matrice in input
param costi{cols};                                              #costo di ogni colonna
var t{cols} >=0, <=1;                                        #variabili per indicare le colonne prese

minimize costoTotale: sum{j in cols} costi[j]*t[j];
subject to copertura{i in rows}: sum{j in cols} A[i,j]*t[j]>=1; #copertura


problem pricing;
#-----------------------------
option solver cplex;
param N integer >=1;                                #dimensione della matrice quadrata
param K integer >=1, <=N;                           #cardinalita del matching massimo
set indexes:=1..N;                                  #indici per la matrice;
param W{i in indexes, j in indexes} >=0;            #matrice dei costi;
param P{i in indexes, j in indexes};                #variabili duali
var x{i in indexes, j in indexes} binary >=0;       #lati presi nel matching
var z;

minimize pr: z - sum {i in indexes, j in indexes} P[i,j]*x[i,j];
subject to vincoloI{i in indexes}: sum{j in indexes} x[i,j]<=1;         #un elemento per riga
subject to vincoloII{j in indexes}: sum{i in indexes} x[i,j]<=1;        #un elemento per colonna
subject to vincoloIII: sum{i in indexes, j in indexes} x[i,j]<=K;       #cardinalit� massima K
subject to vincoloIV{i in indexes, j in indexes}: x[i,j]*W[i,j]<=z;     #z � il massimo