#modello per problema di SS/TDMA  
param N integer >=1; 	#dimensione della matrice
set indexes:=1..N; 	#indici da utilizzare per la matrice
set frames:=1..(2*N^2)/3; 	#indici da utilizzare per i frames: problema come fissare numero di frame per evitare licenza ampl
param D{i in indexes, j in indexes} >=0; #matrice dei trasferimenti
param L >=1, <=N; 			 #numero di antenne
var x{i in indexes, j in indexes, k in frames} binary; #variabili che descrivono i vari frames
var z{k in frames};	#variabili che descrivono il massimo del frame-k non vincolate esplicitmente

minimize tempoTotale: sum{k in frames} (z[k]  ); #minimizzo il tempo totale
subject to massimo{i in indexes, j in indexes, k in frames}: (D[i,j]*x[i,j,k])<=z[k]; #definizione dei z[k]
subject to righe{i in indexes, k in frames}: sum{j in indexes} x[i,j,k] <= 1; #al + 1 elemento preso su una riga
subject to colonne{j in indexes, k in frames}: sum{i in indexes} x[i,j,k] <= 1; #al + 1 elemento preso su una colonna
subject to cardinalita{k in frames}: sum{i in indexes, j in indexes} x[i,j,k]<= L; #al massimo L trasmissioni contemporanee
subject to copertura{i in indexes, j in indexes}: sum{k in frames} x[i,j,k]=1; #devo trasmettere tutto una ed una sola volta


